package com.madeu.dao.web.webcontentsboard;

import jakarta.annotation.PostConstruct;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.support.SqlSessionDaoSupport;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Repository
public class WebContentsBoardSqlMapDAO extends SqlSessionDaoSupport {
    @Autowired
    private SqlSessionTemplate sqlSessionTemplate;

    @PostConstruct
    void init() {
        setSqlSessionTemplate(sqlSessionTemplate);
    }

    /**
     * 고객 상세 - 고객 상담차트 정보 총 갯수 조회 (total count)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectTotalUserConsultingChartCount(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebUserConsultingChartSqlMapDAO selectTotalUserConsultingChartCount START");
        String sqlId = "WebUserConsultingChart.selectTotalUserConsultingChartCount";
        logger.debug("WebUserConsultingChartSqlMapDAO selectTotalUserConsultingChartCount END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 고객 상세 - 고객 상담차트 정보 리스트 조회 (List)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectListUserConsultingChart(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebUserConsultingChartSqlMapDAO selectListUserConsultingChart START");
        String sqlId = "WebUserConsultingChart.selectListUserConsultingChart";
        logger.debug("WebUserConsultingChartSqlMapDAO selectListUserConsultingChart END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 고객 상세 - 고객 상담차트 정보 리스트 조회 (List, Excel)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectListUserConsultingChartExcel(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebUserConsultingChartSqlMapDAO selectListUserConsultingChartExcel START");
        String sqlId = "WebUserConsultingChart.selectListUserConsultingChartExcel";
        logger.debug("WebUserConsultingChartSqlMapDAO selectListUserConsultingChartExcel END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

}
